<%@ webhandler language="c#" class="ContextViewer" debug="true" %>

using System;
using System.Web;
using System.Reflection;
using System.Runtime.Remoting.Messaging;
using System.Threading;
using System.Diagnostics;

public class ContextViewer : IHttpHandler
{
    public bool IsReusable { get { return(true); } }
    
    public void ProcessRequest( HttpContext ctx )
    {
        BreakIfRequested();

        ctx.Response.Write("<h1 align='center'>Call Context Viewer</h1>");
        
        LogicalCallContext callContext = (LogicalCallContext)
            miGetLogicalCallContext.Invoke(Thread.CurrentThread, null);
        
        if( callContext != null )
        {
            ctx.Response.Write("Call context is present<br/>");
            
            HttpContext ctx2 = callContext.GetData("HttpContext") as HttpContext;
            
            if( ctx2 != null )
            {
                ctx.Response.Write("Call context has HttpContext data<br/>");
                ctx.Response.Output.Write("ReferenceEquals(ctx, ctx2): {0}", ReferenceEquals(ctx, ctx2));
            }
            else
            {
                ctx.Response.Write("HttpContext not found in call context<br/>");
            }
        }
        
        ctx.Response.Output.Write("Hello from page thread {0}<br/>", AppDomain.GetCurrentThreadId());
        GetCallContextDelegate gccd = new GetCallContextDelegate(GetCallContextFromPool);
        IAsyncResult ar = gccd.BeginInvoke(ctx, null, null);
        callContext = gccd.EndInvoke(ar);
        ctx.Response.Output.Write("Hello again from page thread {0}<br/>", AppDomain.GetCurrentThreadId());
        
        if( callContext != null )
        {
        }
    }
    
    void BreakIfRequested()
    {
        string breakArg = HttpContext.Current.Request.QueryString["break"];
        
        if( (breakArg != null) && ((breakArg == "yes") || (breakArg == "true")) )
        {
            if( Debugger.IsAttached )
            {
                Debugger.Break();
            }
            else
            {
                Debugger.Launch();
            }
        }
    }
    
    delegate LogicalCallContext GetCallContextDelegate( HttpContext ctx );
    
    LogicalCallContext GetCallContextFromPool( HttpContext ctx )
    {
        ctx.Response.Output.Write("Hello from pooled thread {0}<br/>", AppDomain.GetCurrentThreadId());
        return (LogicalCallContext)miGetLogicalCallContext.Invoke(Thread.CurrentThread, null);
    }

    const BindingFlags bfNonPublicInstance = BindingFlags.Instance | BindingFlags.NonPublic;

    static MethodInfo miGetLogicalCallContext =
            typeof(Thread).GetMethod("GetLogicalCallContext", bfNonPublicInstance);

    static MethodInfo miSetLogicalCallContext =
            typeof(Thread).GetMethod("SetLogicalCallContext", bfNonPublicInstance);
}
